#
# $Id: SmallCard.pm,v 1.4 2006/05/01 06:42:42 kono Exp $
#

package CardPlay::SmallCard;

use strict;

use vars qw($VERSION @ISA @EXPORT @EXPORT_OK
);

require Exporter;
require AutoLoader;

@ISA = qw(Exporter AutoLoader);

@EXPORT = qw( );

$VERSION = "0.2";

# use Tk;
use Carp;

# class method

sub init {
my ($self,$w,$image) = @_;

my $tmp;

$tmp =  << 'EOD';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EOD
$image->{'c1'} = $w->Photo('c1', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAAM+xk5RYVrnFvMd6Z52CeZpUSDIdMXVuoayzw8qQbWY9Q+KvlaRY
VczZ1ahXT5iXrMeEauvVuLt8cunk16Ojuvj06cbUxb+QeWhditWFcTodKMFuZJWJlXRrmbzJ
xYN9q7SusLvDxNiVd4F8n8mVfMjL1IZUTvTAe/S4e6WaofXo1cyrmbapq97w0otwbfHRsOzk
zGxBPoaCqlhCSMWzqfzLk87hzP3kodbWytKqmLlnWNLN0I+RrFtJWJqgxIl+hV9clPfUm/Pt
4+fHqamzuPX08uLMxbqCae+vcpOMqal9dubb1vXex/3TmodnZbh1XfKsgsx6avrEjY1XV5+V
mvLd0cbTyvrbmummeevbylgtMHM9OpZkWbeHdsNnV21ml/XIi/Tz7de6qW1jjdmNc83Kynlz
nNva2/3IllxShvTCjWhFSdnp0oNVU+z16GRckfz02tmEbMbIxqywvfXEkdnh6eKRbmpdZapn
WL16ZLK1vOzr60UvOqyuwIlNSKaco/z89IZ2fdJ8aJGGi66VjYyIseS1oeW8mJyduk4wPN63
m5mOltfozOeZeXlRT3tNUerBlkg3Q0IzPal2aub715tcWefUy6mrucO9wvy8je7BiXt1mbK6
u7h2aNLizefm5TwpOquFfKxyXKGXnXdISbm8xenOvKynq5lLUKGftKNhXbZcUpqct8eJc9rF
t2troNfW1dKBamc6Oczcylw1OIyBiO3Sr/S8i812W8RyZtuKbK6NhfzSls6gioV5gXJla7dr
Y8etpG5hZ7iYiMnUyvrz472lmnhrdP///zIgLHhSU45wg5BKQ/XMkrWbkoN8o5CMs/a+k3Bk
jXp1pKOktdimhrmPgp92b3lJTf377CoSJ/royKZqYueohPbbo7W7w9jY4oVOUt2kev7++viq
hJWTtKR/hNO8sv7jmtiXa1hNgrO1xIiFp9TMtsmXh1g7Q5WUrcS8upyit9XJxJZnYva2iLez
t/S0hvbTleu1h5iWswAAAAAAAAAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJkyWLFBD
PkYYSpxIsaLFixgFJuNTJRCyX8jMYBw5kRw5khY18iF0D1UyUMBGniQZyCFKihpBdQjBg+Gw
m0CDJsvJCNAchniEKh2ZswogkcmSLp2KE8BLRiqgSqXKNScgUj2T/eTa1arOEFWS8YgpU4uE
JsbIVn0JKJkgYMDQYCSH5MSfHXn+nCAml6FGoa82wMu2gA2bWrV4FT4c9IQiKCX0OdHkeNYK
uZSTxeKD0RiiJ7VG9ErnLI2bR5a6aCNLGdUBSWIuMigxgY04T94suSoD79GWY7StMkQlSZJN
ikRkdXHcrQSuEl7KwVuWrUDyZOQA/hGCh4dQppL6vpTpMimbI0e40mjSVI9GLTbf5W0LJSmU
skkTrZAFAVLo0g0VugSjgSP2lEMJPDSwEUNZyTAhiQ+ECDIJWwxpkUUWjnTzCA2e6OKNE7hI
AQ8bj5TiBYXJRGTLPRUd4sggRHgBz4qeOEKALvaw0QcNs3TBDVWhyRNLRVmkAEMcq9AAzyRs
WNLAJuksQQIy8NRiDZLKYWTFOCkko4UMtSjigxqWRJFOLzXM48A+JEC1VGgWLZJEJMmsIIMM
eLTxAzZTpJOPGaZUYAote7ADyp1hXjQCCk0wxE0M7ZjiQAtZTPGNA+2AYconjdAyTwXP3YQn
RVYkEUZc/gzxsM40mJixSxbucMKJIXTQAY4LjdCByaNArToRAymEYRMfA3TCSTxtZKGPOWDQ
0sk+FSBgSiUU7DEPHaShZCxD4RDizJfJiIHJAJWIAEcC3hSSwB7FFDPDPmBQk8AH1mJCjV4k
jZsMOx98Qo0R4cRTTTWfzMFJD5EoccUcc3xiygd0qAENr8WAU0ERdl4k8D4izHFGAp3Q0oYI
7NBCyxmo0OHAByLQ8snN7ZzhgQf7tCICOAPMkepcF7UyDzE6JHIBLRfsAwItLtwDDTg5FFOx
y+xU0E4G0IAxQyd7JNJJJ+FWNG4gPTiACCqJzKCKEnCcUXAxXl8MdRt0gIBJ/jUZGMNHDxAU
EU0i8wwwtGGRluTBBWzPg0kRe6CBRicTg+EBNOawYwodM0TTSiJ4sMPQHp3MIMIFA3wy00QC
m1NEAvO0g4kdDBkBTSL7QMMJGWRQAwII0QyegCFKSERBPPPs88EFq4M3VOIUnbNECWVkUSlD
EKgBBgJnQJMBGWeAMIMhiZijSjsTVTPDBe7QQpFDAjPxhSY22JDFLgzMlswc08DB9TQZOMMZ
qBENP8yhGO2ICEPY0Y4bDABgRLMIPVhhj3zkAxd3uIM+jsSQTniABGfIQDtmAI1oVKAVdAhB
bhiCBjjEAxpvoMhJBEaOYCQBC0LIhxw4IIddEGEm/piAw844sTE6uOwD+1gSQ0DhgT20Y2iz
EVgyXjEIZ2AhRVkIwxo+FIk4kAMCYDhDO6aRr8wxTnQsbEcbIHC455HEC7twwgjqgAUL1jEM
+MCFEJgRBFiAQQ1wQAACMPGGzzCEHswQRAtEBj2KMKEBjtBAHb4Rhnxg4ZIWtAE+SnCOe5gg
E7FYgQROsYh3zEYaWZBDG91IElHkgQPewAEWwqAPZzgjDM7IRy9sYA98cMMhgdCHFG61Bkrq
4xQZaSRFjsGFBqjGgt6QQx6FYEtbYtAb5DBGLlhRBhvkIwwp8AZTlDmRV2SjHp6wBy60KAtd
4OIbdVgDLr7pjBRscAzv/nAFAT7kjRUyEiU5mAUvKLELG2BhDVHoBgHKsYY64MKWFsRFFvTX
gicwQVzklAgTZuEOUTQDHzioQzk8kQ0gxXMNa8iHLVOACImwQIHjRIkYZlGIHHRBFr3Ihz3u
sBgpOCIKEsXFGpyBQf3FYAgYRUkguDAGdLhhB/jIRx0c0QA3iEMXcnBEFqIQBXtk4QvITIYE
YJpMpW7BDcSoQQN2kQ8bOMJErqCCADgwiDLIoQyDYIUwkhEDd6gKAM27iAzowRAvsEIaaSiH
AIIxn3dQIhWpCEYwVtEAa1SCBRT46yon0oUaMOQIqXDEZhrABimUIw1O0Mc7pBCMbqTCF00t
/lZGJYINYsSgEPUQxyCckIZuwAMSDRiEIzThBGlQQRxUIMYLLiHbmzxDAKUoxWsaQFwNuMIa
lKCCJQggXFeUwBWUEEAXMptUlBwjuo9YxjIgIVpv6KKr3uiGGwSggRG4whOrEAAlmmteLrjB
qtkoRR6cgA8q5NcSIlqAAMThBu2WgrmblYgUJXKMekyRCuiogQCyII1g1IMKbKjHEnjBAk8s
IQ6UOMFsLBBYs82WIdd4kSiOcRJhfCENGmDDM5AwoWQ0oQRP0IIAFmAB/raSFzE4wUyG8AB7
OOIPhYgAeYMxBHpgoB5/IGtMUSIKDFACHRPpxh2c4A0CQOEzpygB/kPq4QY96K+8rWyGmifC
gkFIwx5lIEBcXGHIFswCCRFm3YuT4QUDvPmzucDHFFyhh0BowRcSCcQfFBCUCTOEEl2oyBB2
oIlejEDPtyCrG0bRYlAgY2iWTgamA0uOL0QBC9aIABEkQJEnjGJoc0ADENDQgtWlugzjsMg7
7oAFb+ghEoF9hzpSxYht0AAZNNgGISQ8aAWgiyKX+MIU6gAFIlTEF+NIlS220RxJKCMtiFOq
OhZhkUCwIgtOIIAOKhIADk5kDoyQBCEuSm2UDCEJcbjIBHZRB3UcoiI6OLRE8BAKH0SwNOlo
MXjeMQgNeIPW0JG4CiTBiIfvBSMT+IIupvTR44kE/CItTvVI3sECFujj5CURispJMoZbCCUW
AIPpzEdyBIWP5COCsIURpp3uwhhD4haJBRAY8gszLL3ohQkKvhkChDnYot9RD0omVMAQW/Dg
6azM+k0yQQqqOx3rYkeJPLieDCCYgehhT/tI5FGXZNjCDFeHutwxYmo+8GAYsfgF2veO8jkI
QhBoMEIIBk94lM/E14NuvIslDymFWP7ymDdIQAAAOw==
EOD
$image->{'c10'} = $w->Photo('c10', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c11'} = $w->Photo('c11', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c12'} = $w->Photo('c12', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c13'} = $w->Photo('c13', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c2'} = $w->Photo('c2', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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$image->{'c3'} = $w->Photo('c3', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c4'} = $w->Photo('c4', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c5'} = $w->Photo('c5', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c6'} = $w->Photo('c6', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c7'} = $w->Photo('c7', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'c8'} = $w->Photo('c8', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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=
EOD
$image->{'c9'} = $w->Photo('c9', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d1'} = $w->Photo('d1', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d10'} = $w->Photo('d10', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d11'} = $w->Photo('d11', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d12'} = $w->Photo('d12', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d13'} = $w->Photo('d13', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAAKGtiqejkP3CkuTj2eJ7e/THf4yFcu/Qm8rZqM6FZ1tWWXhkZcHF
s/P17qqQYc3jrvCsiPPWueWDhPXd3JuglPHEjPTbnOe4ls3Wu6+Fiu/Vl6vNoGtLUbrDsuY7
Rvv69ZWYfYeYg+mam9bMyt3i1NfSt+7w6N7jy/38+umjaYaEbsCIb6NvbcC/k/X08ohWWciW
evrYoYKXd+iLaO7Y1G9TXvPUmueGiNqWe8PapqvHldXpseJMVa60ooySetCGhe3Yq5mTlLie
beKYhqi6iPLHpvXprKGbn/r18+7EmOfJxrSigOTb2td8e++3usmsr+qjnvj1yb2rrfLJldrq
snJvVvLcoumzoL3VnKW9ldCKd/rx4uulouNCSLNwa+/otseve+rr5vv7+vDIoHJNVqaWdeex
ivPh2/HMjenyx63HjN/c5fThnZaIeehGUNfMxvLnxvLwvGZHSvvYmvfrt92Laal5buiumLCr
j+tKVu7rxTchLMqMd55bY+7MpP377v3kouXq3fXlpFQ2ReOCf+ytrNjlr8bCpOnGtvS1jOvk
u/DUlbi4qupSW/7DmfDJylk5Q/fKiPXsyMLLrePbqe++v+WPkXuOe8uyrMWGeLPKlMl7csyY
go58ZvTsyvTbqePp1+zElH1bXOSrf7C+kfTb1O6ndf7yrPPV0/Plq25pZOedmdPO0d6ohqt+
dfLMtM/cucDIp+iMkPvsrJ13cbaHefTSjrW3psiNjp2ti9a5tuepiOqUlfru7Z5IUfPFg+ya
g/LUo3x3ZP///6S6i9ejeOjp5fjq16mlhuJlbKifheWUk/zws/Ts6qqIkfPrtM3Fx9zRrtjJ
qpu4hezLltTcx+zEjJCnhPbp5ey2jOWLjN9tb/rz7PS6l/2yjPi4h2U8RuqcobSgkNTuuYVb
YmBxZeqrg9ioj+J+grrLpkg2PfHru3pRV/nx2vLYxuc6ReRucAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJiTGsKHD
hxAjSpwIUSDFixgzPrTYkIK4ERQ0itTIkRiFCalMFUg1suXEkpdCEsuGw6XNjQA6NkySLuOx
VtFa3cQZcdsTjEgIwQgH41WToQxLMkxVyBBGDevaadJ0B8YoqMSkGirgi1gKik3CdYCxtMyc
OeOglnxyiWE3ZhSzMdX2qJMrGHPayc3JsEC8CRPizbpoo90db+Ve3SljY7DDFEmSdDsbcVc0
YjZyeKPzyNuXOR0sixyza8yYKV84EVH0qA8hBqobjqE4hkRDWE6ceGNFiE/coVKJRUEz8QUc
h3gibPETyQ1YqSC81JToLJPDGr/8/nzZBTYsYWJJ4r3pYTXiiU4OuSipQwdW+ZLMHDlaXxYi
mhyANATIBaqAk0MS151HzCzwOJKNRFgoEEdDXFgwyQ00tIecgsSwNxEe3EzIUBxBfHLFKbwk
+BAkCEoERx+TMAQCgWBcAM4pL+SWERudgMLQH9ccMcgAwZzijI4YQcGCDMQQ4EkMqNDRyRcK
MLfhSOhsMUATAejiSjPe2IJJEWIgeZE2VAQzDgfJUEHLN7VQswkIZlJkQSBbMGCOG4HIEAwD
OqzhQJ0TKUHHGTAsYAsqj3CyCg/UlHmlSEsYEwgR5dhCCzgtiFAFNccQKlEjrygSiCja0PEN
AwGQswYK/qJG1IgJOYATSJS8MLADBJuoEytEuKBAhh+nSCJJLatokUAWxVgzqUa4CALILomA
o8ECq+iygw467OCsTcldhMsxZ3EmwDA/YKMFBFmsEQu4HF7kg6QNibHMDysUc8i+OrzbUrgU
qTPoQxX8MIwuVVSRwCYhlPBvvBTJQudDiKxwQClqqEGOFiJ48PBIEkNEwDAH6AJBxhxg4sPH
IlGyG0RurCACt+pwMIPHIwE8kb8QCcEAE5UEvYgLJ7CsUQYSPcMCKlLUQUufLuksUQMS5XIG
KuzQosoFokQN8URIRwTEOVizc0Qbf3g9UtgQbXFOM9CwMwgw9hmd0bcQ8XIO/jR8t2GAKWqL
hPdDetOyBzRzcxG4RqFI5A0pRywCTRuScJbz1xIJItEf5wzCDjsXIADvao1HJMwZV3x+ixGj
a5RCqBEFgQcoqqgiiQStZwRC0RG9gwEVFxxhADK5Y5TCwBAhI0oEN9SRRjfFDwXCH7zQsYcw
E9s9FBfVYEDgBTdJPRII3d8wyAaWX17ej9oMcsTz0Q8lgR03QJMG8YuDZYodCEgBDP7aG8o7
aKCKT/wvfjd5xynilobsqW9970iDHKBRjYwciSjrEwYj2LGBOmSkANBziPhGwogNyIERLaJI
FODRCwyWJw1XAIOPLtIFL+jhA8yw3Ag1AoINQAMU6u7AiCH0cENW6BBzI3HHBtihCo2ssIUi
RKJI4sAIVcRII8pwoHnWF4Qr3AKAGLlgFMvzCfNJIojPugkILHCNNtBBGr/CCCxUcAMwSGMI
n7jISS6Bg15soz9bHMoxjGGMSnxiGg9A40QsMQKGUIAbKdyhRMYABzOYYRpyYIIVKoCRzMwk
HVaKihQnggsrHGAIYWCCD0SQo4yMYBsPGuNNGpCMZeSBAMRoJUZwcJSKjHJ9DoGEOBqSPkkC
kyGW6CUxmAFIYx7TFwVAECS2ccRjiiQVE9gGMxzoTGtKpJve9GU4N6SQcprznAYJCAA7
EOD
$image->{'d2'} = $w->Photo('d2', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d3'} = $w->Photo('d3', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d4'} = $w->Photo('d4', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d5'} = $w->Photo('d5', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d6'} = $w->Photo('d6', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAAPTLk+yaZ+3KlrODcXtYZfCto/rbnFlIVOZIR/bXmKGLX/n209iE
Z3t1id9EQPXYuPj1yGxibfrjn/395LmFZu+rpaais8eKgemKZ+r4henLtsuoiP37+/zyb+dX
WFk8Q8OXiqVXT/z7u+B6XmtJTr+PhtlsV/7+9eabdNbT0ev3lui3efv8s+rf1KyTivTji7iy
ulhCSOzmuMSJZvnl0paSqal0UsiUd9WXZvf7qPvxrGlYX3ZleW1hhGxOYt6HW9upmuqJfvn2
9p6CienWuPbZp1wwO/GPXfbX0vbjk/XmXaKQkPj9mLZ5W+eCXf398/DPYsXCfdCxfvrz3JKH
oce2qpNuVvqdbMJwYPHHpeuokrByYs2ynPfHl+VzaPPky/nzs9fHtvz8w/rMk8urp856cvvr
zOvOw+I5OlEtQ/vz49aJc3x2mPLLrLiAXPOadf/wc1xRaMnCyd0qK9iXeNnSyPT26e34t+ip
d9a5pPHUZbuATrm0evPZiMVoWPTry/3z62RVdsmpl/T3t/Tby+nEiOfVp/jSmvz8zNqmdmc7
OqaDhXpsiOrn2Ou2oee9aIR6lfXKxbN8TPXl0vPJucOsYuznyfOqbbBjU9bTsJtgXOi3g/v2
vfDocLyahpOQrbuunP7/otZ1V2RTa/bouMrYhsmSa4V0iPK6sevWlvvs1H1gadXpivCamO/Z
Uffpm4hmTPb73OuVieS1mdebiY+KbePmkev3pvXt2764pdm5jvfoqKdzZ9R8ZauCeM7Qz45u
bMaRTdeelqdrU////0MwQPbXyKZoSOvJpunaxfG5rKGXpsykd+RWTeSpiPKoeIRNWPrs3PLZ
Xblla9rJrPbo2KWiZP397O2ZlPP5jPjoxvTSq3dYWNakh/fp5v7++s6WVOhrZNmpWP3929fD
mPi6h/vs4+mna9e3mPjRlMvLt/W1etqkZoxdVfnGi8K2uOl6df381OVkWs3Am+7p4+qLgwAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJizGsKHD
hxAjSpwIUWAxKK4yZvxGsaNHiha/xTv37Zu4JB9TqixmcYgkhpKyrZzZ0aLDeB1o6oxok6GF
VDQ75NzpsGexeDNRKEB2wxDRhj2TyEyJTds4ZCUseYDxlCWAhhZeejzzbVyUcCwUaR3Xtac9
lB2xbShjKVyeFjowjRPW6WnPQB+NpEsH6RS0OpzeZUI2DRtRox85cdg1KVYedzQUuZMhTN7j
ryrBKcKhCFKDdwHecZoVbZKSzw7FPqTgUFGFTTlu1CGzxZeZWHtekdtpNIHshokcciJWgk+J
XurIkBBxJc6S5Dp7zkrzAcrDQ3Pg/on/FIxVsDaRiHDIdGSRsGnDs4O2l+BDfXAN5zTy4aNR
myqgXFBFIxIEA48duvTRizAjEAdaJQkkkMZUDdlQhQ0xCIhKDwjIEAoDUJzTwTHFlOOJgw1V
Qoc9DalwgQ02vBgJExvy0I0Vq6xSQw0MBbKNDig29AVgczATSRv/tdHIOjM00kM061AgTSD4
VQIGN5QUAxhNRg1RjAoOyCGIfw7oIksxLwhCCitgQCDNOSQmAcWZEECwAZegQaQCMF5yMoJn
v8jxwwta8EiBNTUUUgwgq2CDgjdergRZRHkoMZwhBfygSyLSaAEBGiisUckuyRSzRjpDqTQp
RJzA4Bkv/jggwIgRjwQCRSnWgBNIOY5gU4NjM636kCFKvMrCJkzUKU0hEQxgTTFFhFAKBGtI
E5pXHgUAi7E4vPDIIGegRMgGNWjxSS60SYNCMfh15J2wDg0AQwtKcdKtGGIEsYo0ydBSRDEz
dMGNG24AktK7eU40gBI6UDCAEbVYEUIyIZCzDQRFYHAMBJoUEQE2EEiasETcKNECOQrAakcI
EQwyiBtQQFBOOdwAEoIBZxyziqojR8SNHy0kMoAXFdTDQTLchDADNlqUks4hWlRTxBmFSAOs
R/A2pIUf8mCjgCGK3NHFISiIUQ4EZ5BTSzq0cJPOv9Z491HWDPFSbDE7cHLK/h0h0BLBMp/Q
UooWMxwSRDK7cAMnIFR0tC7dxfycHAWc0ACFHqVss40J4GJzTB3JrEHBLhCAA8HOFD3eM0RG
KEEbOYbQcEcZVNBSTCifGDEEFc9WEkgRG0BRAxTr1rT6QxDAsm4i75wCThDHrFGMFYwkp8Wy
dbphAhrFbFOJ3A+1i21HRkwQQTGJxD5ENcnUAAEHXUDgvvTnuFGMHV1AsUEdxT/UP+RbOx8F
1HeJSzyrDEFIBBSGcQziQeEY59BDLTLghYlQAD+QGwDXioENVdBgCEWgBTiO0YVHZK4aM7he
MXLkhmfAgRsTSQRtMmiE4VAgAE4oxgYAEYhS6AED/oVIBC1CcIjBMWAbz3iGL2wnEXAMB3Kc
4IVnyMGJHIphA5WAwDCIcIgInCEItahFCtiAg1oYgQ1/oAgGj+cQFhghOWOoYjEc4Y0GwCEL
1QgCNaJhBji8wwvm8EUdzvAEdPRPIpDLww4aFEcneEkaAoDDH8wggjzUIQVkQIQRjIAFbpCj
FHNjI0PAwYIIDIcBLPggQ9jhhVI1gB3myABqyOAFJEAgVcaLSykpgIId+IEG9dASOsxhPwNQ
MAPm8IImBfCslNBtDSwYQyLIEQZe5MARxahBAGbAjW3cYRSxnCUisCA+rImSgywYwZ/GMIEc
uKAYVFhDKcDhnTpA4wnm/qAlO/Igso6sAR2d6EQE5AGLcCjDIcVDQwae8A51BICV/aQIFdCx
SF6OoB0HRc4ofUECdhzgHZgAQ0QnQgUW8GIMjulEO95pjUtgYwZFAMMMGnACdRgBpO0CH0jO
SQV2wGKa2BAFC2iRAyccwhCqiKcpnHACMiiAHZxoyJlGORG6UcEQsCgGOQh6CgLMgAOOIEci
hpKNE7wDEZiAISVUAYEIzMCtVT0nNLfViQHUgRi5YAgHOrAuR2HgDw1FwgCKcFBAuPRM2KmI
XE3KC0PkwBAVwOaiOHCJYuBBFtQ4jTqQ0DiGUGAGDbnaQ55p0h2EQQkKcEJl2XWLcgQCD5X4
/kMe1KEOAXCEXcX4LG3i2pFzsCAMYZDHAQZAjMqCIwKywAYvbsGJBuThowI4RDlmsDRsXAIM
u+XJOa3Bgh1IcQKGuEFeL0KBDkChA9BIQR5g8Y48oAAK4DDYKHU62u1S1LQDCO94HTKEPEAD
GhNgBzTOCwUKyOIO5uyINdoRBmzIwxA43G9DvoEJ/xoBlg0ZAh4QnEuKFILBHIRw0SDyjWGm
4ACYqERDUMAAl3a4nA4pwm9z64fUBvMha0AmHMggAGsxJLkMWEM5l1HfieAHAnkgBAdhwYs3
vDN8AmAHBQUAkak25Bzn2EJRzrmBduzgIjs4gBPsEJEGQIMN5jBH/kc64Aw6OGNL45vIBrpr
Kl4o4BRiiAgb4JACc6iYIuJIwwPScAK50Y0WJsWGNA6gCjzrOQN1EICiPPyBBzwAKAyBV6im
wAkjYMMaA+CFIvRwkfkWgw1sqAMQbksRFRlgyxO5RTMMUQcFUOAQ3uAFC6wwAlxgQxYoPXUD
VA3jiIBDCEWWCCBUYYhmHIICOCDACHjhDUJ4ZwV40GoDRkGDJ6QExqvChlibcAtTHCIdNyjH
IQ6hiGo4URvaaMInNuGOHnBBBxrQQCKwQbxQGhvf8G6FIfrQihVo4BaqUAUhcJGIMZSiBzaQ
QxUK4IcmaAAXW41PhyEyAgpgIxEtgAUe+PCAF1w0oQnaWAEhmkAPQXCoESVIBhRWkN2IQMEC
sI6IaOUxAh2MoQVjGEMTTL6CJvSCFAiwhQRkUItDSuQbyIbKORkCBWxQAAqJwIUsOkEFnlej
GwWIRRds5I5DBH0MTm9IKnAu9ZmA4+2quMYCFhALY4AgGLYoQTTUIAEdaEMD2kA7ROzB6jh/
5O0NAUcrWqEJZvTBFFKwhS2uYQqUt6DfD4F6sneCDceAowUnb4IoRj8C0T5kFnBpe1dCS46a
T0QSLCp1pqdu5J0MASkMmcVtIbd6iEjiA7OwxyzmsXva995/QwiE8lV//LYYv/k7VYj0p099
gwQEADs=
EOD
$image->{'d7'} = $w->Photo('d7', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d8'} = $w->Photo('d8', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'d9'} = $w->Photo('d9', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h1'} = $w->Photo('h1', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h10'} = $w->Photo('h10', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAAO3DoPqlgvSrfOenWPzy6vjZmtK5mfG4sYdKScVpW+ZXVOzm2vPJ
VtN0TtjXpfi4fNZ6aOE7O86PgY5hTPe6ktuXZvHMTdXHjufixOmqmPysg/KZbOnJO3dJSfTt
ysmWSv7ui/TeP8Kxj95MSIp0WMR4Wevs4si3befYx+W1Tt2fL9unWNV4Wf352aGMYVcwM/fX
ZoZVSuR8a/b9/XU7NvrLlP3yZeqSdMR7PtmUd/7jm/rGiphXS7lbW+KeWPu0i/vyeuAxL9eX
V6haVP7+VdeNgt65Tda+euqlhLtpTIhXUr+CXahmV/WZe+m0ZbZ2aP7/YtnCVeeYd/WoiPCM
bOeId/fCjfjUpenJieSJavnzSefCvNmZivWyi8WFSFxCRNitoP7+W/TXWO2el+dsY/vboWRF
RfThW/rp4vbGpo1wVvTTxfWrhPjm1vfIk/vJjfz8h7p4SsKtoemUa/z55/PGuvSbg/r4sPq7
jJRLU+fbpPvUmuZjW9yoSqhqTPvMmue4WOy2iLtsYuzOymo5Ov797G9STO3Yt/7goP3+TKVU
SfSkfHk9TLRiW9a7p++sorNaWuzTQvq0henISemnZ4dQP//uZfvFk4NAO//+aONHR/a6hM2H
c5lkV/XHZfvcePvCjPfd1PO2Wf77yuEpMbyshsZoYv799ed1aPPbUvG0rbJqYvXcSuzWVfXo
NuZNUMuTd+mmeuuZhsOyfPnJmrd2Vlw8QvXbgtWJWdaziPu8kq5kYdmpi/aodpE/NOzGWM+Y
YPzSluMsL/v7OPezhNSgfNqZTZFKQeWFWPuifvj0Vvv+RUs3PnlEPf////fmVd6wNs2Fa/G5
rK+Qa9uhaMl3Z/zHe4ZOULVcRvGOd8qVV/S8afGspfW7i9mGc+zquv7++rSfl9eDZ7JlPJZ8
aZdYU7plW35mTseHV982N+7Qfea9k/KqauLd0fz5m/joS3hUSPPhe/bDktWnlueuS/781aSR
X+bMeOyUe+Ddk8l/cwAAAAAAAAAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJnzG8Fma
aQUaSpxIsaLFiwwFSiyQCqPHjx81StTGMBzIkyhFNpyBsuVJlQw7upx5UaOoNM/CsaTJc6JG
DQgY7uxJVGO3bjGJKtWYpg+kGUhRsmnRqQsrKAFQ9RSZBgGblqssKfFQKIEJAu3smJwJs2U4
ZDIgECFrgluLX0QYsAVAE5W4GuOs2dqxx8I1JZ4Q72U4C+KMoB5F/ephrpAuUvYsyKrkq0WN
Ey412hGyINWmTVoxdmmEzVw6Hr0MzLM2KEEzGClC8xWl7vSmPh+nOAOzBFOSWJ6yGBjAqlkh
N7qFboKlzs7HCR6kDRBmjMKgPHk6/nmCQc5Q9GeoSKiz8tGNJRhQduVJZONKHnOHbi2CsJhh
NwkReeRFJs2cwcgGZvCxgzdTeGKOA6m1pBIqGoDkRjaFNDHABowY4E0nkzSBjQN19OeSNPEU
M44BOvigRQQR3HKLEuad55IuuuwgjTd44HCKNWeAYcsoNUrI10yCCCOMIJEIAkQTYGBjQjKg
0NQWSNNMYYOS+zQiowdLWOPAO1YeKVUEnLxhgwHF2AYGGIecMw6ZJoKUhhZtwJFHEqEIswEU
ZyzRBC/f4OFWRmaCpAEO3hhggxX5mDHJHbwcYg4RCgSxFkipXXlRAVokMY8ZgDhhhRfKmHrG
GbyYEEKZ/ihxEcEdXoDXRgRW3DGDNqzcokclpMB6UhcRaEMFeHngYA0Vd8zKig/cFGkkSkbg
4MQsyLYxyDwGOPHNJHC8U2KdHn2Tz2xUFMNJHhHUkqAXSQjjAk+eWtSJFcLcy8gkNkwhSwi4
XNMOAdLQm6hHE1gzxSBEODFJHm3kAo0qn5hAjjgurVVvRRqcYkws5uCwwTzsfhIDDj3YQkPG
iKIEiRZA7HLOIAKEAogVMniSQDkRoqTxwRjZEUHMTkSSDxB8CBDJEpnMQdPPKDGgwB21bECE
NALUAsQMg5xCT1FAf6qAFUAAMYgeWe9iTRMb9PJ0yyeF48Oyu1iRwDe7ADKL/jVOTPH2MxtT
hMoiRNwBhDKOYHM0EJPQoQV0BqNkxyJ0AGEDEE6YQzMQgGAyiS9qBGjjRz0kAEUnOsyyQQR6
WKEMEJgA8gYEEKiBE6dwfxTGH9tsE8wfS6CzhAexEGvFLBXswjgEtUAOUuANESIHN58MIU0T
niyxxCJ6RdDCOT5EoMUUTjjhSy0vhT1ROCwQ8AQwDTxhAgWHeCKDO89oUMXquriABTuCoAME
KvA89UnEBkH4xDoqMQZQPEEHFGiCDECDilNoIRVfawgRZEEH0dXEgAxxQzQIoIU8zIMTEKjE
ODzhCQo8wg2GCAMRTmELichCFhzIjUeghwt45KIN/nmoxRuSNwnGhcIXSHQCjLKhQzcMQAd0
SEJIQPiMBqgiAuC5whv4wAdhwMEGagrFG3hARl/IohZqsMYBHqGDZGzKIoFLAyX8MA4geGMe
V6hFLWT3hnm8QRh86KMNtsSDAeSiCciwRgsy+EGMsKEDx7ACeLxxBTzOAxDzoOQ8NunHPxqA
DwbAhLKc4AAdvNEnIOSCH4aQDwEUg5OV3KQ38uANb7zhDVoEBBe7aIMkWAMHHPgKHEHIBhBQ
gm+MKEatijEJb0yiArXEhDR34YUKCMILfQwFJk7Biio8opGfYkIMfJArAQggD8UAj3zKBoRZ
ROAb1mIEJ67QhnVNwREK/jAFOC/ChBvY4hSQytUdZpGPfMzCCtbwARFywQhQGuAKEBjAJJRx
Dg8koAQjGKZHoCAJNOjBHLyIhA8iEQlH+EABeuiBdkJhBjO8AWLKEIA2FOCBM5SgHNTQ6EXs
MYRtRGEbCbDFNgLBAiZ8oQnm6IEs4CBNNQChDeWzwjn0EI8SUOMD0kLlRVwwhkA0oQjQMEcl
LqEJYAxhFE/IhS9sgIVdFEOmVLBC4g6BjheMYFz7nIg9vkCJbZjjEmJIhwU+EYUibGEUOMiD
DQCxCydowxqLMMcSSnAPWuwBrxi5kgvecQwQBNYW0ChCOgZhC1c0oBKM2AUmgLCBGSggAQlA
/gc1qLEHe0yrIVi4RCty8IdlBEIaLCiCGFQQCClsIx9eUJ4TZkCETMTjBRjIQFYrwgbrSEQl
IiSGKvQgBTHY4gnbEC4zxBAFMdBhFo8lgjPWMAJw9MwjVgDOdY9kiDgwQxGtaMIygJEOeLii
CMtgRhGiEAVXLII11HiAIcJxSoyIYhMSmMZ8n2GPVyhiGRj+QRECoQpFCFgMLKCEIsrrChTo
wwXvfYYhPkCKdwQBEe+dASxgsQnRacQQzHjFFhShikBAAx7wUAU8liGGMdgiF2MgsiY0IYZW
NCAGuAhBHGKwBWIQQwTyQMQb7bCJBcBCAuyBW32JwYxWjIEAHV5G/pDHcAM02EIBPjBBNT7R
gAaMARh+CAQlLrAFeKjgAxUhwzAWUIZSLKBTiXrHK+BxASIc4cJiKMIqhwAMaLgCGMDoqvsC
gYYtbEESKmBBBizihj5ooNTCBNzB4NEKVxBhCdtwBTTEIIZlJNmwyyiCIgAcBUVsoQPb0MWo
yRWEeozCzlGARgzG4AoVqOACqgjwFnLcikXjAxFgm0gcVpCJP5CDCd7+whCQkIV1vO8CflAB
MOSBh+l+5CYTlogLsoABXSDh3uDALENQYYgUnwQVZZhFGVbRkI0xOCdKqQgCyICeMiA64TTp
BmQcnjuIo6QbBH/GKh5u8ZZInCLQ6/hEKjAOciqKXCIayHi8T/4RMkRl5SzHCBkqpNWYe6TB
qrZ5mRTC85773CABAQA7
EOD
$image->{'h11'} = $w->Photo('h11', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAANNcXPz+VeTwz+lKStbYVPv8a/S6tOuLh46potxtde+5pbh7eenq
18yOhvTcePGIb4Weo4ihnPF8b8isWvSujJlDQHY0OJanmd+EiOGlWO/vwv390/eYe69IO+cr
LXJRWOqZeHhKVPWKeea0VvjIlvz8tJhWT9WRd21GSeSqqvfSmHl8huBseIWKlfbVuOemhYpW
WG1MONdmW5dzSte5lnVkbqVXWPrLlHuLmPm3k3NrefKma9Gwcqs+QP799Pmzf/v9XLmpePjG
i4xQYObZrvSYhN3XT/v9c7taVoiCS/b0eIV6h/XuTLWGU+tXV9m/ist5dseGaLplYmdiZqRR
SfbIt72Pf/nXx2g9RqbLqtiGaOmxifr7jLpqW9zIcntHSMiMWK+Bcfv62fPnWv7+yNh7dV9U
Yfinh3t1eemIa4xOVaZrVOe4l+l5dezX1ObJTaRERerOcvn6m+xWV3hyWOvaiqpLWO64duY4
OpVVV9SpY/fkmdedZrZVZ/GqpLBtTZZxW/zvgOvUduRlXLhOX+O1YficbPnMm+V4avCfmbZ3
Vvb4MfK2qIlpTvjVp/v7rZi5pddnZrd2ZPr8Y/LcWNCfTuull/f1asRqXVM+R7aNcPakhLe9
yvr6ufWnedqIea3RrPu0jMtqZ/rq5JSrpL6XZ25KVLTYrMSWeuukfPq7hOqwZ4iXmPuzhfn6
k+rYVrjIs/fzh/j5SfjIptrMhZSOiciWWfnEk9d2aPr8g+POkfzBjKh1VPna1cJbWvy7jNdz
XumViv////n5o8NTR/3np4RIS/f6WOqHd++Xk/bly/r7fMuujdqoiNq3qeTOVvj0r/a3ifOl
mvnre+znV97c0fGNgahzbufXZvushLzgrPrk3JhQZfv29O7tcKhsZOvMYOzWTch1acjpsf7+
+s/pz2podvbMmbCzquyVa+hrZPXrZtWxVMucaGU9UMaId/ysi5doVsZdavjn1tawYvTIxY11
bfbDkvz453c+R7i0WPno5P/+7QAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJhw2jJQ9
LN4YSpxIsaLFixiHCRzGLRkWZYoyihw5cmOjAwzdkFzJUuLGA/ZStpxZEsCwA1Zk0txpceMf
lMNU8hzq0qYyAjGTEV368sA0e8Ja2kOQQQWppRpt+nJzIA8hlhni+LDgo1hMohuH+VJk5UA5
kr6KHQsUKAaYG77Q2typwscmY8YemcniIS/PtDNpjTohZQUiYaNSXOAydGO5P6S8KeM30kqA
O+BgXBsXQ88FGJVtTvuwzk2edSOnFQLRBl0uGOP0aIp62GYjAnQm0BGacdqdG6Li/bq27tix
JGVmvs3KcB0dOgQMZ0RwJ5cUUZnM/uSSp0kGUJppfREgoIxkshshwKAIkSTJlBRZLjDQzhLx
0YgjJTNKPFUQ4cAkXniBwiooWOABFjMhxk97JGGhihE3iBAIYKJowwciqlQhRYR7MQTgSMsA
I8kaa7zjgDE6JIMLDsCEUEUU9PRXYkslaIPCDTGIIIIOiHRghDS8uJJMHNjoSBM90sDwwjx+
iBADDojgg0YywAzhihrgODnTI5zAwM8vIpwiQgXAACPNOIl0KYoa3KyE2Er04JDMC/3wMkoM
RKAhygqAccElL5+oc1VNYwKTCBecmCGJPqe44UoZA5iDyj3w8IIDECGciNGdI5GCQwWSgDJK
FV40I8YV/iWYk0ApkSRwDjar4PBJBYyy9AIORgjohTP9DJNOJOm0EkkpEbiQAxX3AAOEOvxN
NB2pItHSgRvjLNDAMOWUg0EkTLBQLhMSNHvOGzx8QplF1+44Ei2SzHMFRbG4kAYVO6TRSgIR
JHCPN6qsEoJI2GZECz6cbJGLMHVO1EAaObRSigSt7FBOBbyoM91FCV/kjTQl6KDNJxDk4kA+
E1mzAwallNLKOd60sYoaLI8qb0b04IMLJ5ygUUEHKaswkS0sSBBJJOd0sswqn+SoM0tY4FMC
J0ZUIIrWHQQzzhsMwaxFKKhE4oIvQESdUcgWLYDPIx38kkwHQVeARiJJPOON/i2ooEI2OQk8
AwwPUoO8M0Y6ODaCM/Cs8wkaaOhQQTK/YENrOlqgQo4WOVxyyDJrH35R4jpAsEA5mUAQTwU6
xBNPMnrswISyWmwTCgsMfPJC6Ct580kJohBSRDkNBDNCPDpMIzQXXODySBFkp3POPR3sXlG8
K+XjCiJGFGMNQ/RsocaR0uDwCJY4NLILBrbUYQoEeCChyxxlQMIy9nB9osMEXkz0gyoky9KM
VqADUTyAEkEgQz1A8QlMBCEIBjAAFCbCNopYwRU6kEQzJoKF8iECB/hAByJooYMHGEAXXUgh
F8yQjE9kIxiAoEYZ8DeSBaxiBL/I2TBo8QlpoAOE/joA3jXwwIwuzAEJXWAGOzQACEmoYQ+e
iMgPGFLBieACCJKogUQa8QkcrAAd+MBH69wAA2YwYw66oMQSxKEBB9yDBlDox3RoKBJ0oCEX
01lAF42BiJJpYwQtkIIskMCMV1CCGQ8IQx8g0Y9ifWyK1BkJN272DIYsIAQ4MB8iEKEDNxRC
CphAgvxEKYs+HKMH0ZnaSLDwiRlM0QqfaJMOHqEDI8zjBvWgBCWMyAxkIOEBU3jHLhAmOorA
DQXlwAIQMgkMTrhhHlGgAAILSQxiGOCQPegGG0wAScORBAdueEY5uDAEfMSjBYW4AQWQQAkB
MMME1ewCMoKABHCcQggc/hgD70TSD20kIgoLcIU2RKGAO9QjguxkBiTg+Qp2GoAaYKhFKvfJ
M1dwQgEh6JAbblAAdlYDE12oJjHmwAxdGAAJ7oiBLDzRq4y8wBWjGIcrXGGEO7iDHV8YBArn
UE00YsKBlNBDDzhAkioOAxfJmAcMVoEGBUxiCdnIxhxMMIeqkpQZoqSEBsAwiG5S1CL9eAUQ
FAAKXohiBIX4giiRONIuvKILaYwgGU5QC30WtZhzCAIl8DEObfBCG5KQhy4jaMS36mIJSAhl
EG7RC0gQ9a4XIQYjgiAIB2xhFX+8AwWK2AVMGGAJumDGT4uIhEqcQAgmkIVdiXmRWcxCAEOI
/gIaXBE3eXyjsJRAhi51iQldpDEMa7BDGVgK2YpIVgBNAEQIaDupAhggpJ1Voy5eQYwuICEI
lhjHGqIBLjvtDBKuxW4UeNGBdehDCRFEo27n4AkTeKK6lJBDL44hgza0hFSvCC8sttChdYDh
FMh4LjHYuQSGWtcAhuhFL1IQjY8VlyH5RYYABNAHTgD2BI4oACUMcEQ1GlYXpQ3DJEyhBxB0
wcEtLUd4BUCCDsRDAfKgADSumUJMUGIOXYjgAwxxCyfUwwlg+MIciiWmYXBgFhIWhzpe3Isj
kIESP53DaGVh0nC4gw922MMk3sEGO7xiohUhRU4oWCJINAEZ7Fhy/gv0UABxIBAOssjxZymB
hGwswhM/GAMfJiGCHjTysRb5AwEogpglVKMJn4iHG7qxjybAwgDQgMYrDBBKGxsAEKaQSD4M
IYU5eNUiT8jDNMjMEA5UgwysqGUSBPtoA7Tjtrp0aB9oYAyGhOsR9fjBpyki6PVoJy3UgAMP
4mGERIwCHNBgBzMqcQTrIiPASOiDHvbw6Q3seiLeIMATnkCAdQAoLXwwhBHckIlXMWCzSIDF
N3TxbFG6A0hyMEEZiEwSe+ThCesgQB44Qx1vcIEWtIhCIGxwBhDUowuUgEZW5ZfgGNyCD6md
A0u84QY3cMMNwvi2TX5Qg1RMwhF1AEEKtVLgCExUAhaVaEc72CEHJwCiHoaIhh0eAOjUSKQc
Y+BAP7C8ASE4wRL16AUNHEGDW0BhF3ywK4p7Y62KcGDIEjGBCbBiIkIXkyH94MC1iaIIQlT8
11en+kUOMIE/8AMBRRH7TKZBigNUnI5qH4ki6nQAb1Mx7HGfyDTy4o1rpD3vJGlEnbyB9rsD
niR7H0bf/374jByAFsOwQuEj2XiFCQMBi6J85TEiKs1v/q4KCb3oR2+QgAAAOw==
EOD
$image->{'h12'} = $w->Photo('h12', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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$image->{'h13'} = $w->Photo('h13', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h2'} = $w->Photo('h2', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h3'} = $w->Photo('h3', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h4'} = $w->Photo('h4', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h5'} = $w->Photo('h5', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h6'} = $w->Photo('h6', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h7'} = $w->Photo('h7', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h8'} = $w->Photo('h8', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'h9'} = $w->Photo('h9', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s1'} = $w->Photo('s1', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s10'} = $w->Photo('s10', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s11'} = $w->Photo('s11', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s12'} = $w->Photo('s12', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s13'} = $w->Photo('s13', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';
R0lGODdhNQBTAOcAAAAAAL9fZqNwaOHe4NmYaPu0kGZCTdnJt/n7yXhSTsmrpPnZspFrd8LF
tPzXobS2xEQvSebNs/fyqZRdZrWEg/joqqVfT+rp5dbM2IZYYur0x/r75Pz83OHd3HlpdqWj
q97wu7ZpZsmYifPs0+Xj46iXmqyptZyVopWQpXlGQe3TrKplWs7LyejmyPn03N/nyZWLm3pM
WaqaqcakieebeIN6fOCoktviu4B2eYVsfv/lmerl18WXfraBbNDNzq5ZYe7fx/Tr5PT02vHd
i4FVcNh7acK8ttbYufn04nE9SYuGoemXbG5iarphX4BXXpppZ7COjaOcq66zr0o7TWtIU4h9
l8R3b4V7lJSNppuTmVZBXEMzRvX05KqHlIJ1kXpyk4lthNqgbaBQUnBBUdbUwtCHgdmHdrm4
ts3Jw/v9+sK0q/Tt3OXZypV9lq/Dzbmai/b66+qog6FpY/jal4h5iYJPVYNhbcvFxF9SZI9O
RNrX1uz318VnYsmCc1s6SfapiIyCmpCIitPbu4yChv7++dudgdS4m2xcd8XBwdynmZiFi+/R
h61wV+Pk21hHVu7v893i1fzOocnQvujLq/T70XNobZGFm/Wsg/j49ujk45KCktjZxphUVubW
tuW1qNrNyHRkheW7lJuete3s69zRol1NYcS9xtrEquOHe+nzyX9zdbWmqvb2uKynq/e6i8qe
l9+ghGdUZMmQa9eIZc9+cXZadvz87Pr06vTEi5dLUbiinNzQsn5xjqObpXlriXRZbfHkovvb
ov////PRmt2mdPa2fMvKuIaFnLSssvjGldK7tfTz9KpkY/a6k93a5PHnxvrru/Dv8KifsPvU
m//VlTwsPOrInvTKlNaTeua3ecO9vbKis/fZpLh9bfGbhLWfrKN3gOapecajlb2njLSzruGi
arOrrZB6jr/Asr21uvnqtqujpXVUWWc8SOLtvbq2rbazs/T2nfX16p2Vl6BMSzIeOJSNoti2
pvz99Nvkw/LisgAAAAAAAAAAAAAAAAAAACwAAAAANQBTAAAI/gABCBxIsKDBgwgTJhTGsKHD
hxAjSpwIUSDFixgzPrTIsFGvdZg0ihTJkQWOO/A8hBzJciJHHNEYNvjQsmZFAAxZNNSTxaZP
hhwd1vDx02dQYT5UIStqFCfDQIFGMW3KcJ45hnrSTW1pMY2jQVnmMTkT0ZatUQ8eBGlE5s5W
YRwxjbqQaUCaiIT0ncDyCYoBP+04bZp6NOOVdW8Cx3DSLU8npoUxaoMSw8+KUNiq6dIF2SnD
qxcpUGEGi8eMYH96SC0aVM+WCxRFtBudbAa2az3kEXZKiMkWDxMjJMmQgVMcaMGa8bC1myGd
KaW2tJK4wk8GK8wKOEhWoNsTQp2F/mXa4gjPFEcSaYxxIoddswpFQsRI4SI8iWpMSpyXqIaI
lypfMBBKHL8c0kNzwpDgQyCNwAbRCTlokk5aovDyhRt6hAJNeAxFA49EveTiSgFlUCBCIuCc
s0oicyzCIUWj/NKEDslRQ800yTSTjCvB4MLcT5FBlM4vfFADzDVHNnONAw7g4gouKrDm2US9
1MKHK9PgMs0wTjrAzQI0ZLOGlBgBckgIlwRzSTjQPNOMK4XgE8FjP9oUpEOYXHHIBKhcY4YI
+OBDyC2vRNCQLfhQRdEygIBiBzYj2BKSC8/UZyhDiCo60Sj2gFLLKz9mytApl3IA5JQRXbCN
F4dQMAkC/hxwgIA6z+BjQx8HCLPBqRc1ckYbXjxhhTgqTHJPH31YQ80sAuhTZ013NgSJKeec
8AsnPxSCTRzXJPNHEbR08wqZFDWijYQ5MONNJAUU8IcZYlDwTARBkDtRIyb4oo0vdRTxxyx8
BPCDGIZsFS1WHxyizTkxiDGwFbB480cBBqMK0Q5BlNBAFpzwQcMl2v0xTTG7vijRBnLiowya
FVCTTDDcVEAKGQhSxAXKR4ACwymrqGHMDS9I0oBu9mJ0hy8noPFOOmS0QMkL5BgjyAtwaIqR
KV4AgkwvJ7RCTgMyWNJKA4K4k8oeibIkEHgZwQPKFzCcQM4RdBtjjiVnGJNP/iogaCCE2hZP
hIYXXliCAjxH3KABJRoIgs4JojSQDyVmj3TwQ3dc4QUMx3zwzs83uMO4IK2ggA4Z+WiQigsu
UAIr2xFFho8LCAADDDE8yCILD0p8Qbg9WfSCzDubCJJPPggYcUwrqaSyiwQSsMIK7LEHzhAC
8QxRDgGyEPBGKx8cgwIMgFRxwiq9oNAAJQ2AksXxuyAgPQIXBYmPEOqwUoEEc4QhSx/dgEIJ
ooAFJaAgCvbghS/IkYpegKIVZPjADHCRjUUsghVpqx5E8MGKRWQjG2EgQDjKEQZGWGAFFmBE
AtjRgxIoQheaiIIgLFEFdKBjFaEYBjf0sQAMuiRw/i7QhwpUMKdnjOCILlhDEJBwC1vAAR9I
gIH5jAEIe0jiHUTTyOU0gol59OID8OgF2QQBuJEQ4oyCgl0H4iaFKPRCEDfIohatxxI9wAAe
Z7CHGghRtTIyZROAIAc6NMGJGSCBK3QciTiMkShMLCEY0EqkSJTxhiAEwRO4sJMkNXILetAi
HEsoGSJ/Ajs+zIIa17BaS9i2DGYsgRob0iQpnUOEQlhDGarUCCEw8SNFaKENHjCGNHJJEXxw
YQ0rEYYMIKCiWiBjGxgxh1ZuchF88DKNDlkDG2oRixIM4BslWAWM1mEOZJhjGRuxnjy4wIVE
4SMI9XEIEBRQixx0QRgY/jhHLyhSg3rUoJ+BSCdEbHGLZO5gB1ygnjCQoIAc1KILhFjGIGTw
iImUoBqOcIR0BOqQMzpkB7eQCCbuoYhSgIEhYFiFMyaCiYxOIRbUdEgfGXKLEVDkFLqIxUmF
QQdtmIIiLCBPJmLaEHmsAXYbmClE2HCKEbCBIedYBzQp4oF9ErUhhGCnPORhi3VyAQ4KxYQh
xuEgFcngInpwEEcvQgh8wIELQuBq2o7ZEDDQwQsrHSVL2qpQhijiEL7AQCTfIoxPaOEQq4EI
C+6ACETcIbFA2SRL0qEIiRAiFshoBTIcAZqGbLElLZBIGtbBkEwM4qpbSWZE0pCFQag2soTF
QEgjKvFTDcaWqmpF7W0dMgo6NMQHbnHIZ9+iCrYNgijClexbEKEKeARiHrrdLW8RoQfbSteP
17WcQrbL3e4eJCAAOw==
EOD
$image->{'s2'} = $w->Photo('s2', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s3'} = $w->Photo('s3', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s4'} = $w->Photo('s4', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s5'} = $w->Photo('s5', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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=
EOD
$image->{'s6'} = $w->Photo('s6', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s7'} = $w->Photo('s7', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s8'} = $w->Photo('s8', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);
$tmp =  << 'EOD';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EOD
$image->{'s9'} = $w->Photo('s9', -data => $tmp,   -format=>'gif',   -width=>53,-height=>83);


   return 20,20,52-1,82-1;
}

1;
